<template>
    <div class="bg">
        <img class="star" src="../../assets/images/star1.png" width="100%"  alt="">
        <!-- 上传头像框 -->
        <div class="avatarBox">
            <img class="roate" src="/static/img/start.png" alt="">
            <div class="avatar">
                <div>
                     <img :src="avatarUrl" v-if="avatarUrl != ''">
                     <input ref="inputfile" accept="image/*"  multiple  @change="upFile($event)" type="file">
                </div>
            </div>
        </div>
        <!-- 性别button -->
        <div class="gender">
            <img @click="checkGender('man')" src="../../assets/images/userinfo/man.png"  :width="manPX" style="margin-right:15px" alt="">
            <img @click="checkGender('woman')" src="../../assets/images/userinfo/woman.png"  :width="womanPX" alt="">
        </div>
        <img class="text" src="../../assets/images/userinfo/text.png"  width="90px" alt="">
        <!-- 开始预测button -->
        <img class="btn" @click="goDrawline()" src="../../assets/images/userinfo/button.png"  width="120px" alt="">
         <img class="star" src="../../assets/images/star2.png" width="100%"   alt="">
    </div>
</template>

<script>
export default {
    name: 'UserInfo',
    data(){
        return{
            avatarUrl:'',
            manPX:'30px',
            womanPX:'20px',
            gender:'man'//默认 男
        }
    },
    beforeRouteEnter (to, from, next) {
        next(vm => {
            if(from.name === 'TakePhoto'){
                vm.$refs.inputfile.click()
            }
        });
    },
    methods:{
       upFile(e){
        try{
            // let Orientation = ''
         this.$dialog.loading.open('图片正在上传中。。');
        //  let maxSize = 5000 * 1024; //500kb
          let that  = this;
          var file = e.target.files[0];
         var suffix = file.name.substring(file.name.lastIndexOf('.') + 1).toUpperCase();
          console.log(e.target.files[0])
        //   if(e.target.files[0].size >  maxSize){
        //      that.$dialog.loading.close();
        //      this.$dialog.toast({
        //         mes: '您上传的图片过大，换张图片试试哦~',
        //         timeout: 2000
        //      });
        //   }else 
        if(suffix != "BMP" && suffix != "JPG" && suffix != "JPEG" && suffix != "PNG" && suffix != "GIF"){
               that.$dialog.loading.close();
              this.$dialog.toast({
                mes: '请上传图片格式哦~',
                timeout: 2000
             });
          }else{
            // this.EXIF.getData(file, function() {  
            //     Orientation = that.EXIF.getTag(this, 'Orientation');
            //     console.log(Orientation)
            // });
            var reader = new FileReader();
            reader.readAsDataURL(file);
            reader.onload = function(e) {
                that.$dialog.loading.close();
                that.avatarUrl = e.target.result; 
            }; 
          }
        }catch(err){
            console.log(err)
        }
         
      },
        // 点击开始预测
        goDrawline(){
            let that = this
            if(this.avatarUrl != ''  && this.avatarUrl != null){
                this.$router.replace('/starpoint/drawline')
            }else{
                this.$dialog.toast({
                    mes: '为了更好的为您预测星缘，请先上传图片哦~',
                    timeout: 2000
                });
                setTimeout(() => {
                    that.$router.replace('/starpoint/takephoto')
                }, 2000);
            }
        },
        // 选择性别
        checkGender(gender){
            localStorage.setItem('gender',gender)//本地缓存
            this.gender = gender;
            if(gender == 'man'){
                this.manPX = '30px';
                this.womanPX = '20px';
            }else{
                 this.manPX = '20px';
                this.womanPX = '30px';
            }
        }
    },
    mounted(){
        // document.body.style.overflow='hidden';
        if(localStorage.getItem('gender')){
            this.checkGender(localStorage.getItem('gender'))
        }else{
            localStorage.setItem('gender',this.gender)
        }
        // if(localStorage.getItem('avatarUrl')){
        //     this.avatarUrl = localStorage.getItem('avatarUrl')
        // }
        this.avatarUrl = this.$root.avatarIMG
    },
    watch:{
        avatarUrl(newVal,oldVal){
            this.$root.avatarIMG = newVal;
            // localStorage.setItem('avatarUrl',newVal)
        }
    }
}
</script>

<style lang="less" scoped>
  .bg{
      width: 100%; 
      height: 100%;
      background: url('/static/img/starbg.png') center;
      background-size: cover; 
      display: flex;
      flex-direction: column;
      align-items: center;
      box-sizing: border-box;
        overflow: hidden;
        justify-content: center;
    }
    .avatarBox{
        z-index: 2;
        width: 300px;
        height: 300px;
        position: relative;
        img{width: 100%;}
        .avatar{
            position: absolute;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            padding: 60px;
            box-sizing: border-box;
            div{
                position: relative;
                width: 100%;
                height: 100%;
                input{
                    position: absolute;
                    top: 0;
                    left: 0;
                    width: 100%;
                    height: 100%; 
                    opacity: 0;
                    z-index: 3;
                }
                img{
                    width: 180px;
                    height: 180px;
                    border-radius: 50%;
                }
            }
            
        }

    }
     .star{
      animation:blink 2s infinite ease-in-out; 
    }
    .gender{
        z-index: 2;
        height: 60px;
        display: table;
        img{
             vertical-align: middle;
        }
    }

    .text{
        margin-bottom: 10px;
    }

    .roate{
       animation: myrotate 50s infinite linear;
    }

    .btn{
       z-index: 2;
    }
</style>
